QGIS Application - Bug report #20308
QGIS fails to copy all selected features to clipboard for large OSM datasets
2018-11-01 06:15 AM - Mathieu Pellerin - nIRV

Status: Closed

Priority: High

Assignee: Even Rouault

Category: Vectors

Affected QGIS version:3.4.0 Regression?: Yes
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corruptsdata: Copied to github as #: 28129
Description

(I'm not in a position to confirm that this is a regression from previous versions, but it could well be)

On QGIS 3.4, copying to clipboard a large number of selected features in a large OSM dataset layer fails. Instead of copying all features,
only a few features are actually inserted into the clipboard (for e.g., out of 2,500 selected features, between 1-10 features are copied). If
you try to copy selected features twice in a row, the second time will lead to QGIS freezing.

Steps to reproduce:
- Create a new project, and add the following OSM dataset (use the points layer): http://imhere-asia.com/pp.zip

- Select a large number of points

- Hit the copy button on QGIS' main toolbar

- Paste the copied features (either as new scratch layer, or in MS Excel/LO Calc), notice it'll be missing most features
- Hit the copy button on QGIS' main toolbar again, notice how QGIS freezes (you'll need to kil it)

Associated revisions

Revision 986e11b6 - 2018-11-01 12:37 PM - Even Rouault

[BUGFIX] [OGR provider] Make filter by id(s) requests work again on OSM datasets (fixes #20308)

Revision 6d493580 - 2018-11-01 02:32 PM - Even Rouault

Merge pull request #8397 from rouault/fix_20308

[BUGFIX] [OGR provider] Make filter by id(s) requests work again on OSM datasets (fixes #20308)

Revision bf3e96c¢f - 2018-11-01 02:32 PM - Even Rouault

[BUGFIX] [OGR provider] Make filter by id(s) requests work again on OSM datasets (fixes #20308)

History

#1 - 2018-11-01 12:34 PM - Even Rouault

https://github.com/qgis/QGIS/pull/8397

#2 - 2018-11-01 02:31 PM - Even Rouault
http://imhere-asia.com/pp.zip
https://github.com/qgis/QGIS/pull/8397

- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|986e11b6bbd7ad529b90ad58f5b3093bb5ed69bd.

#3 - 2018-11-01 02:32 PM - Even Rouault

- Regression? changed from No to Yes

#4 - 2018-11-02 10:00 AM - Giovanni Manghi

| have noticed that opening the table of attributes it only shows 99 rows, is this a consequence of this bug?

#5 - 2018-11-02 06:15 PM - Even Rouault

Giovanni Manghi wrote:

I have noticed that opening the table of attributes it only shows 99 rows, is this a consequence of this bug?

No, this is a different issue. A quick investigation shows that it is due to{{{
void QgsVectorLayerCache::setFullCache( bool fullCache ){
mFullCache = fullCache;

if (mFullCache )
{

// Add a little more than necessary...
setCacheSize( mLayer->featureCount() + 100 );

M

In the case of a OSM layer,mLayer->featureCount() returns -1 to indicate that the feature count is unknown, hence -1+100 = 99. I'm not familiar enough

with this piece of code to fix that quickly

#6 - 2018-11-02 06:53 PM - Giovanni Manghi

Even Rouault wrote:

Giovanni Manghi wrote:

I have noticed that opening the table of attributes it only shows 99 rows, is this a consequence of this bug?

No, this is a different issue.

thanks for the explanation, | filed a different ticket.
